/*
 * Copyright (c) 2005 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/* $LAAS$ */

#ifndef FINGERS_STRUCT_H
#define FINGERS_STRUCT_H

typedef enum FINGERS_BOOLEAN {
  FINGERS_FALSE,
  FINGERS_TRUE
} FINGERS_BOOLEAN;

/* values acquired on the grip */
typedef struct FINGERS_DATA {
  double strainGauge[2];
  double fsr[6];
  double position;
} FINGERS_DATA;

typedef enum FINGERS_COMMAND {
  FINGERS_OPEN,
  FINGERS_CLOSE
} FINGERS_COMMAND;

typedef enum FINGERS_SPEED {
  FINGERS_FAST,
  FINGERS_SLOW
} FINGERS_SPEED;

typedef struct FINGERS_CMD_STR {
  FINGERS_COMMAND command;
  FINGERS_SPEED speed;
  FINGERS_BOOLEAN stop;
} FINGERS_CMD_STR;

typedef struct FINGER_STATE_STR {
  FINGERS_BOOLEAN open;
  FINGERS_BOOLEAN closed;
  FINGERS_BOOLEAN active;
} FINGERS_STATE_STR;

typedef enum FINGERS_MODE {
  FINGERS_GRASPING_MODE,
  FINGERS_BASE_MODE
} FINGERS_MODE;


typedef struct FINGERS_INIT_PARAM {
  int grasped;
  FINGERS_MODE mode;
} FINGERS_INIT_PARAM;




#endif /* FINGERS_STRUCT_H */
